﻿/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\RandomPlayer.exe
No_UPX=1
[ICONS]
Icon_1=%In_Dir%\RandomPlayer.ico

* * * Compile_AHK SETTINGS END * * *
*/

#SingleInstance force
#Persistent
Splitpath, A_ScriptFullPath,,,,title

If A_IsCompiled <> 1
{
	IfExist,%title%.ico
		Menu, Tray, Icon,%title%.ico
}

menu, tray, NoStandard
menu, tray, add, Repe&at last sound, RepeatLast
menu, tray, add, Stop pla&ying, StopSound
menu, tray, add, Force ne&xt sound, ForceNext
menu, tray, add
menu, tray, add, Edit &songlist, SongListEdit
menu, tray, add, Edit &configuration, IniEdit
menu, tray, add
menu, tray, add, Open forum in &browser, ForumLink
menu, tray, add,
menu, tray, add, &Reload script, Reload
menu, tray, add, &Pause script, Pause
menu, tray, add, 
menu, tray, add, E&xit script, exit

IfNotExist,%title%.ini
{
	msgbox, 16, %title% - Error, "%title%.ini" is missing. `n`nPerhaps you renamed the script file?`n`nPlease re-download this tool`,`nif you don't know what could be wrong.
	exitapp
}


;;; Startup procedures and task starting
Gosub,ReadSongListTemp
Gosub,ReadSongListCheck
Gosub,CheckSongList
Gosub,IniRead
Gosub,CheckingTime
Goto,StartTask
Return




;;; PlayFile procedures
Playfile:
if testmode = 1
	Gosub,IniRead
Abort = 0
if ForceNext <> 1
{
	Gosub,CheckingBlacklist
	Gosub,CheckingTime
	Gosub,CheckingIdle
}
ForceNext = 
if Abort = 0
{	
	Gosub,FindNextSong
	Gosub,PlaySong
}
Goto,StartTask




;;; Reading INI File
IniRead:
IniRead,random_min,%title%.ini, time, random_min, 10
IniRead,random_max,%title%.ini, time, random_max, 10
IniRead,waitTrayTip,%title%.ini, traytip, waittraytip, 5
IniRead,waitaftertraytip,%title%.ini, traytip, waitaftertraytip, 10
IniRead,disabletraytips,%title%.ini, traytip, disabletraytips, 0
IniRead,SurpriseMe,%title%.ini, traytip, SurpriseMe, 0
IniRead,blacklist,%title%.ini, THIS_PARROT_IS_SLEEPING, blacklist,
IniRead,QuietIfIdle,%title%.ini, THIS_PARROT_IS_SLEEPING, QuietIfIdle,
IniRead,n,%title%.ini,nosounds,no_sounds_enable,0
IniRead,s,%title%.ini,nosounds,no_sounds_start,1900
IniRead,e,%title%.ini,nosounds,no_sounds_end,0700
IniRead,testmode,%title%.ini,testmode,testmode,0
IniRead,doubleclick,%title%.ini,DOUBLECLICK,default,1

if testmode = 1
	minutes = second
else
	minutes = minute

if doubleclick = 1
	menu, tray, default,&Reload script
if doubleclick = 2
	menu, tray, default,Stop pla&ying
if doubleclick = 3
	menu, tray, default,Repe&at last sound
if doubleclick = 4
	menu, tray, default,Force ne&xt sound
Return



;;; Starting Task
StartTask:

Random,time,%random_min%,%random_max%
Time := Time + 1
If Time > 59
	Time = 60

NowTimer := A_Now
if testmode = 1
	EnvAdd,NowTimer,%time%,Seconds
else
	EnvAdd,NowTimer,%time%,Minutes



if file <>
	moretxt = `nLast Song was "%file%"
if abort = 1
	moretxt = `n`nQuiet because of process blacklist:`n%stoppedme%
if abort = 2
	moretxt = Zzzzzzzzzzzzz...`n(Sleep mode between %s%-%e%)
if abort = 3
	moretxt = `n`nDidn't play last song "%file%"`nbecause I couldn't find it.
if abort = 4
	moretxt = `n`nDidn't play last song because PC was idle`n(Idle setting: %QuietIfIdle% minutes) 

Loop,
{
	Dummy := NowTimer
	
	FormatTime,NowHour,,H
	FormatTime,NowMinute,,m
	FormatTime,NowSecond,,s
	
	EnvAdd,Dummy,-%NowHour%,Hours
	EnvAdd,Dummy,-%NowMinute%,Minutes
	EnvAdd,Dummy,-%NowSecond%,Seconds
	
	If testmode = 1
		FormatTime,MinutesToGo,%dummy%,s
	else
		FormatTime,MinutesToGo,%dummy%,m

	If MinutesToGo < 1
		Break

	If MinutesToGo = 1
		s_txt = 
	else
		s_txt = s

	if abort = 2
		Menu,Tray,Tip,%moretxt%
	else
		Menu,Tray,Tip,Next Song in %MinutesToGo% %minutes%%s_txt%...%moretxt%

	If testmode = 1
		Sleep,900
	else
		Sleep,9000	
}
Goto,Playfile




;;;; Checking blacklist
CheckingBlacklist:
StoppedMe = 
StringSplit, BeSilentA, Blacklist,|
Loop, %BeSilentA0%
{
	BeSilentB := BeSilentA%a_index%
	Process,Exist,%BeSilentB%
	If Errorlevel <> 0
	{
		If StoppedMe = 
			StoppedMe = %BeSilentB%
		else
			StoppedMe = %StoppedMe% - %BeSilentB%
		Abort = 1
	}
}
Return




;;; Checking time
CheckingTime:
FormatTime,t,,HHmm
if (n = 1 and e < s and t > s or n = 1 and e < s and t < e or n = 1 and e > s and t > s and t < e)
	Abort = 2
Return




;;; Checking if the computer is idle
CheckingIdle:
IdleAmount := QuietIfIdle * 60000
If A_TimeIdlePhysical > %IdleAmount%
	Abort = 4
Return




;;; Finds next song and updates played.txt
FindNextSong:

played = 0
FileRead,Dummy,%title%_played.txt
Loop, parse, Dummy,`n,`r
	played := played + 1

if (played = songlist or played > songlist)
	FileDelete,%title%_played.txt

FileRead,played,%title%_played.txt

Sort,SongListC,Random
Loop, parse, SongListC,`n,`r
{
	line = %A_LoopField%
	If Played not contains "%line%"
		Break
}

FileAppend,"%line%"`n,%title%_played.txt
Return




;;; Plays song
PlaySong:
SplitPath,line,,,,file

ifNotExist,%line%
	Abort = 3
else
{
	If SurpriseMe = 1
		SurpriseMeText = a random soundfile
	else
		SurpriseMeText = "%file%" 

	
	If DisableTrayTips = 0
	{
		TrayTip,,Going to play %SurpriseMeText%`nin %WaitAfterTrayTip% seconds....,20,1
		Menu,Tray,Tip,Playing soon %SurpriseMeText%...
		sleep,%WaitTrayTip%000
		TrayTip
		sleep,%WaitAfterTrayTip%000
	}
	RepeatLast = Playing...
	Menu,Tray,Tip,Playing %SurpriseMeText%...
	SoundPlay,%line%,wait
	RepeatLast = %line%
	RepeatLastT = %file%
	;sleep,%WaitAfterTrayTip%000
}
Return




;;; RepeatLastSound
RepeatLast:
If RepeatLast =
	msgbox,16,%title%,Didn't play a song yet... 
else if RepeatLast = Playing...
	msgbox,16,%title%,I'm currently playing...
else if RepeatLastActive = 1
	msgbox,16,%title%,I'm currently repeating...
else
{
	RepeatLastActive = 1
	SetTimer, RepeatTime, 1000
	Menu,Tray,Tip,Repeating %RepeatLastT%...
	SoundPlay,%RepeatLast%,wait
	SetTimer, RepeatTime, off
	RepeatLastActive =
}
Return




;;; Add time while repeating
RepeatTime:
EnvAdd,NowTimer,1,Seconds
Return




;;; StopSound
StopSound:
Soundplay,c:\Imcertainthisfilewontexist.klf
Return




;;; prepares SonglistTemp
ReadSongListTemp:
Loop
{
	FileReadLine, Dummy, %title%_songlist.txt, %A_Index%
	if ErrorLevel
		break
	Dummy = %Dummy% ; get rid of empty lines with spaces
	if Dummy = 
		Continue
	If SonglistTemp = 
		SonglistTemp = %dummy%
	else
		SonglistTemp = %Songlisttemp%`n%dummy%
}
Sort,SonglistTemp,U ; remove duplicates
return




;;; continues work on SonglistTemp
;;; checks if Songlist file is filled and prepares SonglistC
ReadSongListCheck:

SongList = 0
Loop, parse, SonglistTemp,`n,`r
{
	songlist := songlist + 1
	If SonglistC = 
		SonglistC = %A_LoopField%
	else
		SonglistC = %SonglistC%`n%A_LoopField%
}
if songlist = 0
{
	msgbox, 16, %title% - Error, "%title%_songlist.txt"is empty or not found. `n`nPlease add the full path to some sound files in this file.
	exitapp
}
SonglistTemp=
return




;;; Check if files in songlistC exist
CheckSongList:
Loop, parse, SongListC,`n,`r
{
	ifNotExist,%A_LoopField%
	{
		If A_Index = 20
			Missing = %missing%`n... and more! Too many for this box.
		If A_Index < 20
			Missing = %missing%`n%A_LoopField%
	}
}
If Missing <>
	Msgbox, 33, %title% - Just thought I'd tell you..., %title% will start if you press OK, but following files in %title%_songlist.txt can't be found:`n%missing%`n`n(Press Control+C to copy this box into the clipboard)
IfMsgBox,Cancel
	ExitApp
Missing = 
return





;;; Menu stuff

ForceNext:
ForceNext = 1
Goto,Playfile
Return

Reload:
Reload
Return

Pause:
Pause
Return

IniEdit:
Run,%title%.ini
return

SongListEdit:
Run,%title%_songlist.txt
return

ForumLink:
Run,http://www.donationcoder.com/forum/index.php?topic=25383.0;topicseen
return

;;; Exit the script
Exit:
ExitApp